Index: /XMLIO_V2/dev/common/src/buffer_out_impl.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/buffer_out_impl.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/buffer_out_impl.hpp	(revision 300)
@@ -0,0 +1,94 @@
+#ifndef __BUFFER_OUT_IMPL_HPP__
+#define __BUFFER_OUT_IMPL_HPP__
+
+namespace xmlioserver
+{
+
+// template spectialisation : CBufferIn::put
+    template <> bool CBufferOut::put<char>(const char& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<bool>(const bool& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<int>(const int& data)   { return put_template(data) ; }
+    template <> bool CBufferOut::put<short>(const short& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<long>(const long& data)  { return put_template(data) ; }  
+    template <> bool CBufferOut::put<uint>(const uint& data)  { return put_template(data) ; }  
+    template <> bool CBufferOut::put<ushort>(const ushort& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<ulong>(const ulong& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<float>(const float& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<double>(const double& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<long double>(const long double& data) { return put_template(data) ;}  
+
+    template <> bool CBufferOut::put<char>(const char* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<bool>(const bool* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<int>(const int* data, size_t n)   { return put_template(data,n) ; }
+    template <> bool CBufferOut::put<short>(const short* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<long>(const long* data, size_t n)  { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<uint>(const uint* data, size_t n)  { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<ushort>(const ushort* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<ulong>(const ulong* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<float>(const float* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<double>(const double* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<long double>(const long double* data, size_t n) { return put_template(data,n) ;}  
+
+
+    template <> bool CBufferOut::advance<char>(size_t n) { return advance_template<char>(n) ; }  
+    template <> bool CBufferOut::advance<bool>(size_t n) { return advance_template<bool>(n) ; }  
+    template <> bool CBufferOut::advance<int>(size_t n)   { return advance_template<int>(n) ; }
+    template <> bool CBufferOut::advance<short>(size_t n) { return advance_template<short>(n) ; }  
+    template <> bool CBufferOut::advance<long>(size_t n)  { return advance_template<long>(n) ; }  
+    template <> bool CBufferOut::advance<uint>(size_t n)  { return advance_template<uint>(n) ; }  
+    template <> bool CBufferOut::advance<ushort>(size_t n) { return advance_template<ushort>(n) ; }  
+    template <> bool CBufferOut::advance<ulong>(size_t n) { return advance_template<ulong>(n) ; }  
+    template <> bool CBufferOut::advance<float>(size_t n) { return advance_template<float>(n) ; }  
+    template <> bool CBufferOut::advance<double>(size_t n) { return advance_template<double>(n) ; }  
+    template <> bool CBufferOut::advance<long double>(size_t n) { return advance_template<long double>(n) ;}  
+
+    template <class T>
+    bool CBufferOut::put_template(const T& data)
+    {
+      return put_template<T>(&data,1);
+    }
+    
+    template <class T>
+    bool CBufferOut::put_template(const T* data, size_t n)
+    {
+      bool ret;
+      char* dataBuff ;
+  
+      size_t dataSize=sizeof(T)*n ;
+  
+      if (count_+dataSize<=size_)
+      {
+        dataBuff=(char*) data ;
+        for(size_t i=0;i<dataSize;i++) current[i]=dataBuff[i] ;
+        current+=dataSize ;
+        count_+=dataSize;
+        ret=true ;
+      }
+      else ret=false ;
+  
+      return ret ;
+    }
+
+    template <class T>
+    bool CBufferOut::advance_template(size_t n)
+    {
+      bool ret;
+      char* dataBuff ;
+  
+      size_t dataSize=sizeof(T)*n ;
+  
+      if (count_+dataSize<=size_)
+      {
+        current+=dataSize ;
+        count_+=dataSize;
+        ret=true ;
+      }
+      else ret=false ;
+  
+      return ret ;
+    }
+    
+}
+  
+
+#endif
Index: /XMLIO_V2/dev/common/src/buffer_server.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/buffer_server.cpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/buffer_server.cpp	(revision 300)
@@ -0,0 +1,172 @@
+#include "xmlioserver_spl.hpp"
+#include "exception.hpp"
+#include "buffer_server.hpp"
+
+namespace xmlioserver
+{
+  size_t CServerBuffer::bufferSizeByClient=100*1024*1024 ;
+//  size_t CServerBuffer::bufferSizeByClient=20*1024 ;
+
+  CServerBuffer::CServerBuffer(void)
+  {
+    size=bufferSizeByClient ;
+    first=0 ;
+    current=1 ;
+    end=size ;
+    buffer=new char[size] ;  // change later for MPI_ALLOC_MEM later
+  }
+
+  CServerBuffer::~CServerBuffer()
+  {
+    delete [] buffer ;
+  }
+  
+
+  bool CServerBuffer::isBufferFree(size_t count)
+  {
+    bool ret ;
+    
+    if (count==0) return true ;
+    
+    if (current>first)
+    {
+      if (current+count<size)
+      {
+        ret=true ;
+      }
+      else if (current+count==size)
+      {
+        if (first>0)
+        {
+          ret=true ;
+        }
+        else
+        {
+          ret=false ;
+        }
+      }
+      else
+      {
+        if (count<first)
+        {
+          ret=true ;
+        }
+        else
+        {
+          ret=false ;
+        }
+      }
+    }
+    else
+    {
+      if (current+count<first)
+      {
+        ret=true ;
+      }
+      else
+      {
+         ret=false ;
+      }
+    }
+
+    return ret ;
+  }
+  
+
+  void* CServerBuffer::getBuffer(size_t count)
+  {
+    char* ret ;
+    
+    if (count==0) return buffer+current ;
+    
+    if (current>first)
+    {
+      if (current+count<size)
+      {
+        ret=buffer+current ;
+        current+=count ;
+      }
+      else if (current+count==size)
+      {
+        if (first>0)
+        {
+          ret=buffer+current ;
+          current=0 ;
+        }
+        else
+        {
+          ERROR("void* CServerBuffer::getBuffer(size_t count)",
+                 <<"cannot allocate required size in buffer") ;
+        }
+      }
+      else
+      {
+        end=current ;
+        if (count<first)
+        {
+          ret=buffer ;
+          current=count ;
+        }
+        else
+        {
+          ERROR("void* CServerBuffer::getBuffer(size_t count)",
+                 <<"cannot allocate required size in buffer") ;
+        }
+      }
+    }
+    else
+    {
+      if (current+count<first)
+      {
+        ret=buffer+current ;
+        current+=count ;
+      }
+      else
+      {
+          ERROR("void* CServerBuffer::getBuffer(size_t count)",
+                 <<"cannot allocate required size in buffer") ;
+      }
+    }
+
+    return ret ;
+  }
+  
+  void CServerBuffer::freeBuffer(size_t count)
+  {
+    if (count==0) return ;
+
+    if (first==end-1) 
+    {
+      first=0 ;
+      count-- ;
+      end=size ;
+    }
+
+    if (first<=current)
+    {
+      if (first+count <current) 
+      {
+        first+=count ;
+      }
+      else
+      {
+          ERROR("void CServerBuffer::freeBuffer(size_t count)",
+                 <<"cannot free required size in buffer") ;
+      }
+    
+    }
+    else
+    {
+      if (first+count<end)
+      {
+        first+=count ;
+      }
+      else
+      {
+          ERROR("void CServerBuffer::freeBuffer(size_t count)",
+                 <<"cannot free required size in buffer") ;
+      }
+    }
+  }      
+       
+}
Index: /XMLIO_V2/dev/common/src/buffer_server.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/buffer_server.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/buffer_server.hpp	(revision 300)
@@ -0,0 +1,34 @@
+#ifndef __BUFFER_SERVER_HPP__
+#define __BUFFER_SERVER_HPP__
+
+#include "xmlioserver_spl.hpp"
+#include "buffer_ym.hpp"
+#include <mpi.h>
+
+namespace xmlioserver
+{
+
+  class CServerBuffer
+  {
+    
+    public:
+    
+    CServerBuffer(void) ;
+    ~CServerBuffer() ;
+    char* buffer ;
+    
+    bool isBufferFree(size_t count) ;
+    void* getBuffer(size_t count) ;
+    void freeBuffer(size_t count) ;
+  
+    size_t first ;   // first occupied element
+    size_t current ; // first free element
+    size_t end ;
+    size_t size ;
+    static size_t bufferSizeByClient ;
+  } ;
+  
+
+}
+
+#endif
Index: /XMLIO_V2/dev/common/src/buffer_ym.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/buffer_ym.cpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/buffer_ym.cpp	(revision 300)
@@ -0,0 +1,52 @@
+#include "xmlioserver_spl.hpp"
+#include "buffer_ym.hpp"
+
+
+namespace xmlioserver
+{
+  namespace ym
+  {
+    CBuffer::CBuffer(void* buffer_,size_t size_)
+    {
+      own=false ;
+      realloc(buffer_,size_) ;
+    }
+    
+    CBuffer::CBuffer(size_t size_)
+    {
+      own=false ;
+      realloc(size_) ;
+    }
+
+    void CBuffer::realloc(size_t size_)
+    {
+      realloc(new char[size_],size_) ;
+      own=true ;
+    }
+
+    void CBuffer::realloc(void* buffer_,size_t size_)
+    {
+      if (own) delete [] buffer ;
+      buffer=(char*)buffer_ ;
+      size=size_ ;
+      count=0 ;
+      read=buffer ;
+      write=buffer ;
+      own=false ;
+    }
+
+    size_t CBuffer::remain(void)
+    {
+      return size-count ;
+    }    
+    
+    CBuffer::~CBuffer()
+    {
+      if (own) delete [] buffer ;
+    }
+    
+  }
+}
+    
+      
+    
Index: /XMLIO_V2/dev/common/src/buffer_ym.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/buffer_ym.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/buffer_ym.hpp	(revision 300)
@@ -0,0 +1,81 @@
+#ifndef __BUFFER_YM_HPP__
+#define __BUFFER_YM_HPP__
+
+
+#include "xmlioserver_spl.hpp"
+
+namespace xmlioserver
+{
+  namespace ym
+  {
+  
+    class CBuffer
+    {
+    
+      public:
+      
+      CBuffer(size_t size) ;
+      CBuffer(void* buffer,size_t size) ;
+
+      void realloc(size_t size) ;
+      void realloc(void* buffer,size_t size) ;
+      
+      template<class T>
+      bool put(const T& data) ;
+
+      template<class T>
+      bool put(const T* data, size_t n) ;
+
+      template<class T>
+      bool put_ptr(const T*& data_ptr, size_t n) ;
+      
+      template<class T>
+      bool get(T& data) ;
+
+      template<class T>
+      bool get(T* data, size_t n) ;
+
+      template<class T>
+      bool get_ptr(T*& data, size_t n) ;
+
+      
+ 
+      template<class T>
+      bool put_template(const T& data) ;
+
+      template<class T>
+      bool put_template(const T* data, size_t n) ;
+
+      template<class T>
+      bool put_ptr_template(const T*& data, size_t n) ;
+      
+      template<class T>
+      bool get_template(T& data) ;
+
+      template<class T>
+      bool get_template(T* data, size_t n) ;
+
+      template<class T>
+      bool get_ptr_template(T*& data, size_t n) ;
+      
+      size_t remain(void) ;
+                            
+      ~CBuffer() ;
+       char* buffer ;
+       char* read ;
+       char* write ;
+       size_t count ;
+       bool own ; 
+       size_t size ;   
+    } ;
+    
+    
+  
+ 
+  }
+}
+
+#include "buffer_ym_impl.hpp" 
+
+
+#endif
Index: /XMLIO_V2/dev/common/src/buffer_ym_impl.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/buffer_ym_impl.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/buffer_ym_impl.hpp	(revision 300)
@@ -0,0 +1,178 @@
+#ifndef __BUFFER_YM_IMPL_HPP__
+#define __BUFFER_YM_IMPL_HPP__
+
+namespace xmlioserver
+{
+  namespace ym
+  {
+
+// template spectialisation : CBuffer::put
+    template <> bool CBuffer::put<char>(const char& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<int>(const int& data)   { return put_template(data) ; }
+    template <> bool CBuffer::put<short>(const short& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<long>(const long& data)  { return put_template(data) ; }  
+    template <> bool CBuffer::put<uint>(const uint& data)  { return put_template(data) ; }  
+    template <> bool CBuffer::put<ushort>(const ushort& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<ulong>(const ulong& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<float>(const float& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<double>(const double& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<long double>(const long double& data) { return put_template(data) ;}  
+
+    template <> bool CBuffer::put<char>(const char* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<int>(const int* data, size_t n)   { return put_template(data,n) ; }
+    template <> bool CBuffer::put<short>(const short* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<long>(const long* data, size_t n)  { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<uint>(const uint* data, size_t n)  { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<ushort>(const ushort* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<ulong>(const ulong* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<float>(const float* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<double>(const double* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<long double>(const long double* data, size_t n) { return put_template(data,n) ;}  
+
+
+    template <> bool CBuffer::put_ptr<char>(const char*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<int>(const int*& data, size_t n)   { return put_ptr_template(data,n) ; }
+    template <> bool CBuffer::put_ptr<short>(const short*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<long>(const long*& data, size_t n)  { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<uint>(const uint*& data, size_t n)  { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<ushort>(const ushort*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<ulong>(const ulong*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<float>(const float*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<double>(const double*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<long double>(const long double*& data, size_t n) { return put_ptr_template(data,n) ;}  
+
+
+// template spectialisation : CBuffer::get
+    template <> bool CBuffer::get<char>(char& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<int>(int& data)   { return get_template(data) ; }
+    template <> bool CBuffer::get<short>(short& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<long>(long& data)  { return get_template(data) ; }  
+    template <> bool CBuffer::get<uint>(uint& data)  { return get_template(data) ; }  
+    template <> bool CBuffer::get<ushort>(ushort& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<ulong>(ulong& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<float>(float& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<double>(double& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<long double>(long double& data) { return get_template(data) ;}  
+
+    template <> bool CBuffer::get<char>(char* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<int>(int* data, size_t n)   { return get_template(data,n) ; }
+    template <> bool CBuffer::get<short>(short* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<long>(long* data, size_t n)  { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<uint>(uint* data, size_t n)  { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<ushort>(ushort* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<ulong>(ulong* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<float>(float* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<double>(double* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<long double>(long double* data, size_t n) { return get_template(data,n) ;}  
+
+    template <> bool CBuffer::get_ptr<char>(char*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<int>(int*& data, size_t n)   { return get_ptr_template(data,n) ; }
+    template <> bool CBuffer::get_ptr<short>(short*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<long>(long*& data, size_t n)  { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<uint>(uint*& data, size_t n)  { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<ushort>(ushort*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<ulong>(ulong*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<float>(float*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<double>(double*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<long double>(long double*& data, size_t n) { return get_ptr_template(data,n) ;}  
+    
+    
+    template <class T>
+    bool CBuffer::put_template(const T& data)
+    {
+      return put_template<T>(&data,1);
+    }
+    
+    template <class T>
+    bool CBuffer::put_template(const T* data, size_t n)
+    {
+      bool ret;
+      char* dataBuff ;
+  
+      size_t dataSize=sizeof(T)*n ;
+  
+      if (count+dataSize<=size)
+      {
+        dataBuff=(char*) data ;
+        for(size_t i=0;i<dataSize;i++) write[i]=dataBuff[i] ;
+        write+=dataSize ;
+        count+=dataSize;
+        ret=true ;
+      }
+      else ret=false ;
+  
+      return ret ;
+    }
+
+    template <class T>
+    bool CBuffer::put_ptr_template(const T*& data, size_t n)
+    {
+      bool ret;
+      char* dataBuff ;
+  
+      size_t dataSize=sizeof(T)*n ;
+  
+      if (count+dataSize<=size)
+      {
+        data=(T*) write ;
+        write+=dataSize ;
+        count+=dataSize;
+        ret=true ;
+      }
+      else ret=false ;
+  
+      return ret ;
+    }
+
+
+    template <class T>
+    bool CBuffer::get_template(T& data)
+    {
+      return get_template<T>(&data,1) ;
+      
+    }
+        
+    template <class T>
+    bool CBuffer::get_template(T* data, size_t n)
+    {
+      bool ret;
+      char* dataBuff ;
+  
+      size_t dataSize=sizeof(T)*n ;
+  
+      if (read+dataSize<=buffer+size)
+      {
+        dataBuff=(char*) data ;
+        for(size_t i=0;i<dataSize;i++) dataBuff[i]=read[i] ;
+        read+=dataSize ;
+        ret=true ;
+      }
+      else ret=false ;
+  
+      return ret ;
+    }
+
+    template <class T>
+    bool CBuffer::get_ptr_template(T*& data, size_t n)
+    {
+      bool ret;
+      char* dataBuff ;
+  
+      size_t dataSize=sizeof(T)*n ;
+  
+      if (read+dataSize<=buffer+size)
+      {
+        data=(T*) read ;
+        read+=dataSize ;
+        ret=true ;
+      }
+      else ret=false ;
+  
+      return ret ;
+    }    
+
+  }
+}
+  
+
+#endif
Index: /XMLIO_V2/dev/common/src/calendar.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/calendar.cpp	(revision 299)
+++ /XMLIO_V2/dev/common/src/calendar.cpp	(revision 300)
@@ -54,6 +54,5 @@
       CDate & CCalendar::update(int step)
       { 
-         std::cout << "step : " << step <<" timestep "<<this->timestep << std::endl;
-//         std::cout << "date before : " << this->getCurrentDate() <<" date after "<<this->getInitDate() + step * this->timestep << std::endl;
+         info(20) << "update step : " << step <<" timestep "<<this->timestep << std::endl;
          return (this->getCurrentDate() = this->getInitDate() + step * this->timestep);
       }
Index: /XMLIO_V2/dev/common/src/circular_buffer.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/circular_buffer.cpp	(revision 299)
+++ /XMLIO_V2/dev/common/src/circular_buffer.cpp	(revision 300)
@@ -69,5 +69,4 @@
          this->movePRead(currsize);
          this->nbrequest--;
-         //std::cout <<  this->nbrequest << std::endl;
         
          return (CLinearBuffer(SuperClass::getData(startpos), currsize));
Index: /XMLIO_V2/dev/common/src/client_ym.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/client_ym.cpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/client_ym.cpp	(revision 300)
@@ -0,0 +1,252 @@
+#include "xmlioserver_spl.hpp"
+#include "cxios.hpp"
+#include "client_ym.hpp"
+#include <boost/functional/hash.hpp>
+#include "type.hpp"
+#include "buffer.hpp"
+#include "context.hpp"
+#include "context_client.hpp"
+#include "tree_manager.hpp"
+#include "oasis_cinterface.hpp"
+#include <mpi.h>
+
+namespace xmlioserver
+{                      
+  namespace ym
+  {
+
+    MPI_Comm CClient::intraComm ;
+    MPI_Comm CClient::interComm ;
+    int CClient::serverLeader ;
+    bool CClient::is_MPI_Initialized ;
+    
+    
+    void CClient::initialize(const string& codeId,MPI_Comm& localComm,MPI_Comm& returnComm)
+    {
+      int initialized ;
+      MPI_Initialized(&initialized) ;
+      if (initialized) is_MPI_Initialized=true ;
+      else is_MPI_Initialized=false ;
+      
+// don't use OASIS
+      if (!CXios::usingOasis)
+      {
+// localComm doesn't given
+        if (localComm == MPI_COMM_NULL)
+        {
+          if (!is_MPI_Initialized) 
+          {
+            int argc=0;
+            char** argv=NULL;
+            MPI_Init(&argc,&argv) ;
+          }
+          boost::hash<string> hashString ;    
+    
+          unsigned long hashClient=hashString(codeId) ;
+          unsigned long hashServer=hashString(CXios::xiosCodeId) ;
+          unsigned long* hashAll ;
+          int rank ;
+          int size ;
+          int myColor ;
+          int i,c ;
+          MPI_Comm newComm ;
+      
+          MPI_Comm_size(CXios::globalComm,&size) ;
+          MPI_Comm_rank(CXios::globalComm,&rank);
+          hashAll=new unsigned long[size] ;
+     
+          MPI_Allgather(&hashClient,1,MPI_LONG,hashAll,1,MPI_LONG,CXios::globalComm) ;
+
+          map<unsigned long, int> colors ;
+          map<unsigned long, int> leaders ;
+      
+          for(i=0,c=0;i<size;i++)
+          {
+            if (colors.find(hashAll[i])==colors.end())
+            {
+              colors[hashAll[i]] =c ;
+              leaders[hashAll[i]]=i ;
+              c++ ;
+            }
+          }
+     
+          myColor=colors[hashClient] ;
+      
+          MPI_Comm_split(CXios::globalComm,myColor,rank,&intraComm) ;
+
+          if (CXios::usingServer)
+          {     
+            int clientLeader=leaders[hashClient] ;
+            serverLeader=leaders[hashServer] ;
+            MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
+          }
+          else
+          {
+            MPI_Comm_dup(intraComm,&interComm) ;
+          }
+          delete [] hashAll ;
+        }
+        // localComm argument is given
+        else 
+        {
+          if (CXios::usingServer)
+          {          
+            //ERROR("void CClient::initialize(const string& codeId,MPI_Comm& localComm,MPI_Comm& returnComm)", << " giving a local communictor is not compatible with using server mode") ;
+          }
+          else
+          {
+            MPI_Comm_dup(localComm,&intraComm) ;
+            MPI_Comm_dup(intraComm,&interComm) ;
+          }
+        }
+      }
+      // using OASIS
+      else
+      {
+        // localComm doesn't given
+        if (localComm == MPI_COMM_NULL)
+        {
+          if (!is_MPI_Initialized) oasis_init(codeId) ;
+          oasis_get_localcomm(intraComm) ;
+        }
+        else MPI_Comm_dup(localComm,&intraComm) ;
+  
+        if (CXios::usingServer) 
+        {
+          MPI_Status status ;
+          int rank ;
+          MPI_Comm_rank(intraComm,&rank) ;
+
+          oasis_get_intercomm(interComm,CXios::xiosCodeId) ;
+          if (rank==0) MPI_Recv(&serverLeader,1, MPI_INT, 0, 0, interComm, &status) ;
+          MPI_Bcast(&serverLeader,1,MPI_INT,0,intraComm) ;
+           
+        }
+        else MPI_Comm_dup(intraComm,&interComm) ;
+      }
+          
+      MPI_Comm_dup(intraComm,&returnComm) ;
+    }
+    
+    
+    
+    
+/*    
+    void CClient::initialize(const string& codeId,MPI_Comm& localComm,MPI_Comm& returnComm)
+    {
+      boost::hash<string> hashString ;    
+    
+      unsigned long hashClient=hashString(codeId) ;
+      unsigned long hashServer=hashString(CXios::xiosCodeId) ;
+      unsigned long* hashAll ;
+      int rank ;
+      int size ;
+      int myColor ;
+      int i,c ;
+      MPI_Comm newComm ;
+      
+      MPI_Comm_size(CXios::globalComm,&size) ;
+      MPI_Comm_rank(CXios::globalComm,&rank);
+      hashAll=new unsigned long[size] ;
+     
+      MPI_Allgather(&hashClient,1,MPI_LONG,hashAll,1,MPI_LONG,CXios::globalComm) ;
+
+      map<unsigned long, int> colors ;
+      map<unsigned long, int> leaders ;
+      
+      for(i=0,c=0;i<size;i++)
+      {
+        if (colors.find(hashAll[i])==colors.end())
+        {
+          colors[hashAll[i]] =c ;
+          leaders[hashAll[i]]=i ;
+          c++ ;
+        }
+        
+      }
+     
+      myColor=colors[hashClient] ;
+      
+      MPI_Comm_split(CXios::globalComm,myColor,rank,&intraComm) ;
+
+      if (!CXios::isServer)
+      {     
+        int clientLeader=leaders[hashClient] ;
+        serverLeader=leaders[hashServer] ;
+        MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
+      }
+      else
+      {
+        MPI_Comm_dup(intraComm,&interComm) ;
+      }
+
+      delete [] hashAll ;
+    }
+  */
+    
+    void CClient::registerContext(const string& id,MPI_Comm contextComm)
+    {
+      CObjectFactory::SetCurrentContextId(id);
+      shared_ptr<CContext> context=tree::CTreeManager::CreateContext(id) ;
+        
+      if (!CXios::isServer)
+      {
+        int size,rank,globalRank ;
+        size_t message_size ;
+        int leaderRank ;
+        MPI_Comm contextInterComm ;
+      
+        MPI_Comm_size(contextComm,&size) ;
+        MPI_Comm_rank(contextComm,&rank) ;
+        MPI_Comm_rank(CXios::globalComm,&globalRank) ;
+        if (rank!=0) globalRank=0 ;
+      
+    
+        CMessage msg ;
+        msg<<id<<size<<globalRank ;
+
+        int messageSize=msg.size() ;
+        void * buff = new char[messageSize] ;
+        CBufferOut buffer(buff,messageSize) ;
+        buffer<<msg ;
+      
+        MPI_Send(buff,buffer.count(),MPI_CHAR,serverLeader,1,CXios::globalComm) ;
+        delete [] buff ;
+      
+        MPI_Intercomm_create(contextComm,0,CXios::globalComm,serverLeader,10+globalRank,&contextInterComm) ;
+        info(10)<<"Register new Context : "<<id<<endl ;
+ 
+        MPI_Comm inter ;
+        MPI_Intercomm_merge(contextInterComm,0,&inter) ;
+        MPI_Barrier(inter) ;
+
+        context->initClient(contextComm,contextInterComm) ;
+      }
+      else
+      {
+        MPI_Comm contextInterComm ;
+        MPI_Comm_dup(contextComm,&contextInterComm) ;
+        context->initClient(contextComm,contextInterComm) ;
+        context->initServer(contextComm,contextInterComm) ;
+      }
+    }
+    
+    void CClient::finalize(void)
+    {
+      int rank ;
+      int msg=0 ;
+      MPI_Comm_rank(intraComm,&rank) ;  
+      if (rank==0) 
+      {
+        MPI_Send(&msg,1,MPI_INT,0,0,interComm) ;
+      }
+      
+      if (!is_MPI_Initialized)
+      {
+        if (CXios::usingOasis) oasis_finalize();
+        else MPI_Finalize() ;
+      }
+      info(20) << "Client side context is finalized"<<endl ;
+    }
+  }
+}
Index: /XMLIO_V2/dev/common/src/client_ym.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/client_ym.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/client_ym.hpp	(revision 300)
@@ -0,0 +1,27 @@
+#ifndef __CLIENT_YM__HPP__
+#define __CLIENT_YM__HPP__
+
+#include "xmlioserver_spl.hpp"
+#include <mpi.h>
+
+namespace xmlioserver
+{                      
+  namespace ym
+  {
+    class CClient
+    {
+       public:
+       
+       static void initialize(const string& codeId,MPI_Comm& localComm,MPI_Comm& returnComm) ;
+       static void finalize(void) ;
+       static void registerContext(const string& id,MPI_Comm contextComm) ;
+
+       static MPI_Comm intraComm ;
+       static MPI_Comm interComm ;
+       static int serverLeader;
+       static bool is_MPI_Initialized ;
+    } ;
+  }
+}
+
+#endif
Index: /XMLIO_V2/dev/common/src/configure.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/configure.hpp	(revision 299)
+++ /XMLIO_V2/dev/common/src/configure.hpp	(revision 300)
@@ -2,6 +2,4 @@
 #define __XMLIO_Configure__
 
-/// xmlioserver headers ///
-#include "xmlioserver_spl.hpp"
 
 /// /////////// Macros /////////// ///
